//---------------------------------------------------------------------------

#ifndef DialogFrameH
#define DialogFrameH
//---------------------------------------------------------------------------
#include "InfoPanelBase.h"

#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <StdCtrls.hpp>
#include <ImgList.hpp>

//#include <boost/shared_ptr.hpp>
#include <memory>

//---------------------------------------------------------------------------
//template <typename T>
class TDialogFrameForm : public TForm
{
__published:	// IDE-managed Components
  TPanel *MainPanel;
  TButton *OkButton;
  TButton *CancelButton;
  TImage *DialogImage;
  TLabel *CaptionLabel;
  TLabel *HintLabel;
  TShape *Shape1;
  TImageList *DialogImageList;
  void __fastcall OkButtonClick(TObject *Sender);

private:	// User declarations
  TInfoPanelFormBase *_infopanel;

public:		// User declarations
  __fastcall TDialogFrameForm(TComponent* Owner);

private:
  template <typename T>
  void buildinaux(void)
  {
    Caption               = T::caption.c_str();
    CaptionLabel->Caption = T::caption.c_str();
    HintLabel->Caption    = T::hint.c_str();

//    boost::shared_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
		std::auto_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
    DialogImageList->GetBitmap(T::imageindex, bmp.get());

    DialogImage->Picture->Bitmap->Assign(bmp.get());
  }
  
public:
  TInfoPanelFormBase* panel(void) { return _infopanel; }

  template <typename T>
  void buildin(T *f)
  {
    Height -= MainPanel->Height - f->Constraints->MinHeight;
    MainPanel->Height = f->Constraints->MinHeight;
    // vcl will destroy the form
    _infopanel          = f;
    _infopanel->Parent  = MainPanel;
    _infopanel->Align   = alClient;
    _infopanel->Show();

    buildinaux<T>();
  }

  template <typename T>
  void setdata(const typename T::Info_t &info)
  {
    static_cast<T*>(_infopanel)->setdata(info);
  }

  template <typename T>
  typename T::Info_t getdata(void) const
  {
    return static_cast<T*>(_infopanel)->getdata();
  }
};

/*
*******************************************************************************
* Dialog Window. Fucking shit, I'm
*******************************************************************************
*/
template <typename PanelT, typename FrameT>
class DialogWindow
{
public:
	typedef typename PanelT::Info_t info_type;

private:
//  mutable boost::shared_ptr<FrameT> _window;
	mutable std::auto_ptr<FrameT> _window;

public:
	explicit DialogWindow(TComponent* Owner, const AnsiString &extracapt = "", const info_type& info = info_type()):
		_window(new FrameT(Owner))
	{
		_window->buildin(new PanelT(_window.get()));
		_window->Caption = _window->Caption + (extracapt != ""? " - " + extracapt: extracapt);
		setdata(info);
	}

public:
  FrameT& framewindow(void) { return *_window; }
  PanelT& panelwindow(void) { return static_cast<PanelT&>(*_window->panel()); }

public:
	bool ShowModal(void) const
	{
    return _window->ShowModal() == mrOk; 
  }

	void setdata(const info_type &info)
	{
		_window->setdata<PanelT>(info);
	}

  info_type getdata(void) const
  {
    return _window->getdata<PanelT>();
  }
};

#endif

