//---------------------------------------------------------------------------

#ifndef RGBColorInfoPanelH
#define RGBColorInfoPanelH
//---------------------------------------------------------------------------
#include "common.hpp"
#include "InfoPanelBase.h"

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "pies.h"

#include <map>
//---------------------------------------------------------------------------
class TRGBColorInfoPanelForm : public TInfoPanelFormBase
{
__published:	// IDE-managed Components
	TTrackBar *RedTrackBar;
	TShape *PreviewShape;
	TEdit *RedEdit;
	TLabel *Label1;
	TLabel *Label2;
	TTrackBar *GreenTrackBar;
	TEdit *GreenEdit;
	TLabel *Label3;
	TTrackBar *BlueTrackBar;
	TEdit *BlueEdit;
	TEdit *RGBEdit;
	TLabel *Label4;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall RedTrackBarChange(TObject *Sender);
	void __fastcall RedEditChange(TObject *Sender);
private:	// User declarations

public:
	typedef test::RGBColorInfo Info_t;

public:		// User declarations
	__fastcall TRGBColorInfoPanelForm(TComponent* Owner);

private:
	// boost::bimap
	enum { channels = 3 };
	std::map<TTrackBar*, TEdit*> _bars;
	std::map<TEdit*, TTrackBar*> _fields;
	bool _slipper; // whether changed by edit or trackbar

private:
	void UpdateResult(void);

public:
	void setdata(const Info_t &colori);
	Info_t getdata(void) const;

public:
//	void checkdata(void) const { /* empty */ }
	void clear(void);
	void readonly(bool ro); 

public:
	static const size_t imageindex;
	static const AnsiString caption;
	static const AnsiString hint;
};

//---------------------------------------------------------------------------
#endif
