/*
*******************************************************************************
* UserInfoPanel.h
*
* VCL Window Panel contains necessary controls to view and edit user inforation
*
* 2008, (c) Timoshenko D. In the context of the VIS City Guard System Project
*
* If some changes appear won`t forget to increase version number
*
* v. 1.0
*******************************************************************************
*/

#include <vcl.h>
#pragma hdrstop

#include "UserInfoPanel.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

const size_t TUserInfoPanelForm::imageindex   = 0;
const AnsiString TUserInfoPanelForm::caption = "";
const AnsiString TUserInfoPanelForm::hint    = " ";

//---------------------------------------------------------------------------
__fastcall TUserInfoPanelForm::TUserInfoPanelForm(TComponent* Owner):
  TInfoPanelFormBase(Owner)
{
}

//---------------------------------------------------------------------------
void TUserInfoPanelForm::setdata(const Info_t &useri)
{
	LNameEdit->Text                   = useri.lname();
	FNameEdit->Text                   = useri.fname();
	UserNameEdit->Text                = useri.username();
	PasswordEdit->Text                = useri.password();
	PasswordRepeatEdit->Text          = useri.password();
}

//---------------------------------------------------------------------------
TUserInfoPanelForm::Info_t TUserInfoPanelForm::getdata(void) const
{
	return Info_t(FNameEdit->Text, LNameEdit->Text, UserNameEdit->Text, PasswordEdit->Text);
}

//---------------------------------------------------------------------------
void TUserInfoPanelForm::readonly(bool ro)
{
  const TColor facecl             = ro? clBtnFace: clWindow;

  LNameEdit->ReadOnly             = ro;
  LNameEdit->Color                = facecl;

  FNameEdit->ReadOnly             = ro;
  FNameEdit->Color                = facecl;

	UserNameEdit->ReadOnly          = ro;
	UserNameEdit->Color             = facecl;

	PasswordEdit->ReadOnly          = ro;
	PasswordEdit->Color             = facecl;

	PasswordRepeatEdit->ReadOnly    = ro;
	PasswordRepeatEdit->Color       = facecl;
}

//---------------------------------------------------------------------------
void TUserInfoPanelForm::showpass(bool v)
{
  PasswordEdit->Visible       = v;
  PasswordRepeatEdit->Visible = v;

  Constraints->MinHeight      = v? 220: 120;
}

//---------------------------------------------------------------------------
void TUserInfoPanelForm::checkdata(void) const
{
	checkpass();
}

//---------------------------------------------------------------------------
void TUserInfoPanelForm::checkpass(void) const
{
	if (PasswordEdit->Text != PasswordRepeatEdit->Text)
	{
		throw Exception("    ");
	}
}

//---------------------------------------------------------------------------

