/*
*******************************************************************************
* UserInfoPanel.h
*
* VCL Window Panel contains necessary controls to view and edit user inforation
*
* 2008, (c) Timoshenko D. In the context of the VIS City Guard System Project
*
* If some changes appear won`t forget to increase version number
*
* v. 1.0
*******************************************************************************
*/

#ifndef UserInfoPanelH
#define UserInfoPanelH

#include "common.hpp"
#include "InfoPanelBase.h"

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>

//---------------------------------------------------------------------------
class TUserInfoPanelForm : public TInfoPanelFormBase
{
__published:	// IDE-managed Components
  TLabeledEdit *LNameEdit;
  TLabeledEdit *FNameEdit;
	TLabeledEdit *UserNameEdit;
  TLabeledEdit *PasswordEdit;
  TLabeledEdit *PasswordRepeatEdit;

private:	// User declarations

public:
  typedef test::UserInfo Info_t;

public:		// User declarations
	__fastcall TUserInfoPanelForm(TComponent* Owner);

public:
	void setdata(const Info_t &useri);
	Info_t getdata(void) const;

	void readonly(bool ro);
	void showpass(bool v);
	void checkpass(void) const;

public:
	void checkdata(void) const;

public:
  static const size_t imageindex;
	static const AnsiString caption;
  static const AnsiString hint;
};

#endif // UserInfoPanelH

