//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "DialogFrame.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

// dialog types
typedef DialogWindow<TUserInfoPanelForm, TDialogFrameForm> UserInfoDialogWindow;
typedef DialogWindow<TWeekDayInfoPanelForm, TDialogFrameForm> WeekInfoDialogWindow;
typedef DialogWindow<TRGBColorInfoPanelForm, TDialogFrameForm> RGBColorInfoDialogWindow;

namespace
{

//---------------------------------------------------------------------------
template <typename PanelT>
PanelT* createpanel(TComponent* owner, TWinControl *parent)
{
	// vcl takes care about owned object
	PanelT* p 	= new PanelT(owner);
	p->Parent 	= parent;
	p->Align		= alClient;
  p->clear();
	p->readonly(true);
	p->Show();


	return p;
}

} // unnamed namespace

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
	_userInfoForm 		= createpanel<TUserInfoPanelForm>(this, UserInfoGroupBox);
	_weekInfoForm 		= createpanel<TWeekDayInfoPanelForm>(this, WeekDayGroupBox);
	_rgbColorInfoForm = createpanel<TRGBColorInfoPanelForm>(this, RGBColorInfoGroupBox);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::AddUserButtonClick(TObject *Sender)
{
	// create dialog window to add new info and pass (via default parameter - third)
	// data constructed by default constructor to it
	UserInfoDialogWindow w(this, "");
	if (w.ShowModal())
	{
		// user pressed ok
		// w.getdata() returns entered data
		_userInfoForm->setdata(w.getdata());
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::EditUserButtonClick(TObject *Sender)
{
	// create dialog window and pass existing data to it
	UserInfoDialogWindow w(this, "", _userInfoForm->getdata());

	if (w.ShowModal())
	{
  	// use returned data w.getdata()
		_userInfoForm->setdata(w.getdata());
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::AddWeekButtonClick(TObject *Sender)
{
	WeekInfoDialogWindow w(this, "");
	if (w.ShowModal())
	{
		_weekInfoForm->setdata(w.getdata());
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditWeekButtonClick(TObject *Sender)
{
	WeekInfoDialogWindow w(this, "", _weekInfoForm->getdata());

	if (w.ShowModal())
	{
		_weekInfoForm->setdata(w.getdata());
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::MailToLabelClick(TObject *Sender)
{
	ShellExecute(Handle, "open", MailToLabel->Caption.c_str(), 0, 0, SW_SHOWNORMAL);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::AddRGBInfoButtonClick(TObject *Sender)
{
	RGBColorInfoDialogWindow w(this, "");
	if (w.ShowModal())
	{
		_rgbColorInfoForm->setdata(w.getdata());
	}
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::EditRGBInfoButtonClick(TObject *Sender)
{
	RGBColorInfoDialogWindow w(this, "", _rgbColorInfoForm->getdata());
	if (w.ShowModal())
	{
		_rgbColorInfoForm->setdata(w.getdata());
	}
}

//---------------------------------------------------------------------------

